package com.bytesw.bytebot.service.provider;

import com.bytesw.bytebot.bean.DeploymentChannelParamValueBean;
import com.bytesw.bytebot.model.enums.AgentParameterEnum;
import com.bytesw.bytebot.model.enums.ProviderErrorEnum;
import com.bytesw.xdf.exception.NotFoundException;
import com.twilio.http.TwilioRestClient;
import lombok.extern.log4j.Log4j2;
import com.twilio.exception.AuthenticationException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.twilio.Twilio;
import com.twilio.base.ResourceSet;
import com.twilio.rest.api.v2010.account.message.Media;
import com.bytesw.bytebot.service.ProviderStartupService;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

@Log4j2
@Service
public class TwilioService extends ProviderService{

    @Autowired
    private ProviderStartupService providerStartupService;

    @Override
    protected void completeData(Map<String, Object> info, String SmsId,int agent_id) throws AuthenticationException{
        String sid = new String();
        String token = new String();
        int MAX_LIMIT = 999;

        Map<String,Object> data = new HashMap<>();
        try {
            boolean exist_agent = false;
            for (DeploymentChannelParamValueBean agent : providerStartupService.agents) {
                if (agent.getAgen_id() == agent_id) {
                    if (agent.getChannelParamName().equals(AgentParameterEnum.ACCESS_ID.getName())) {
                        sid = agent.getValue();
                    }
                    if (agent.getChannelParamName().equals(AgentParameterEnum.ACCESS_TOKEN.getName())) {
                        token = agent.getValue();
                    }
                }
            }
            String[] images_droped = new String[MAX_LIMIT];
            Twilio.init(sid, token);
            TwilioRestClient twilio_client = Twilio.getRestClient();
            ResourceSet<Media> media = Media.reader(SmsId).limit(MAX_LIMIT).read();
            int cont = 0;
            for (Media record : media) {
                Media.deleter(SmsId, record.getSid()).delete();
                images_droped[cont] = record.getSid();
                cont++;
            }
            if (cont == 0) {
                throw new NotFoundException("No se encontraron imágenes para dicho mensaje");
            } else {
                data.put("images_droped", Arrays.copyOfRange(images_droped, 0, cont));
            }
            info.put("status", "success");
            info.put("data", data);

        }catch (com.twilio.exception.ApiException e){
            if (e.getMessage().toString().equals(ProviderErrorEnum.AUTHENTICATE.getName())){
                throw new AuthenticationException("Credenciales inválidas");
            }else if(e.getMessage().toString().contains(ProviderErrorEnum.CONEXION.getName())){
                throw new InternalError("Fallo en la conexión con Twilio API");
            }else{
                throw new NotFoundException("No se encontro el mensaje para dicho Sid");
            }
        }
    }
}
